/*
 *  Java Reference Types:
 *   - Arrays
 *   - Interfaces   (objects)
 *   - Classes      (objects)
 *  
 *   
 *  Subtyping: the "is a" relation between two object types
 *     - the subtype supports all of the operations of the supertype (and perhaps more)
 *     
 *    Class implements Interface1, Interface2
 *    
 *    Class is a subtype of Interface1
 *  
 *  
 *  
 *  (Single) Inheritance: a subclass may "copy" the methods of a superclass 
 *    Class1 extends Class2
 *       Class1 is the "subclass"
 *       Class2 is the "superclass"
 *  
 *    
 *    
 *  Overriding: a class can re-implement the definition of an inherited method
 * 
 * 
 *  Static Type:  The type of an expression determined by the Java compiler _before_ your code 
 *                is running.  Uses the syntactically declared information.
 * 
 *  Dynamic Class: The run-time type information associated with an object determined when it was
 *                created by using the "new" keyword.
 */



public class Main {

    public static void main(String[] args) {
        /* Bat is a subtype of Animal */
        Animal a = new Bat();
        
        printAnimalInfo(a);
       
    }

    public static void printAnimalInfo(Animal a) {
        System.out.println("Common Name: " + a.commonName());
        System.out.println("Characterized by: " + a.distinguishingFeature());
        if (a.isWarmBlooded()) {
            System.out.println("Warm blooded");
        } else {
            System.out.println("Cold blooded");
        }
    }
    
}
